//+------------------------------------------------------------------+
//|                                              II_Insanity Rat.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v.1.0 07/8/10                                                    |
//| code by bredin, except where noted                               |
//| donations can be made via PayPal to bredin@lpemail.com           |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010, Insanity Industries"
#property link      "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=JEHPJ5XSPPN62" // donate link :) good idea blubbb
#property indicator_chart_window

extern int object.layer = 6;
extern bool green.rat = false;
extern bool extreme.rat = true;
extern bool zone.rat = true;
extern bool all.rat = false;
extern int entry.style = 0;
extern int price.size = 3;
extern int hud.corner = 1;
extern int pos.x = 100;
extern int pos.y = 100;
extern bool show.extreme = true;
extern bool popup.hud = false;
extern bool draw.box = true;
extern bool box.highlight = true;
extern bool alert.on = true;
extern string alert.sound = "alert.wav";
extern color color.box = Silver;
extern color color.box.border = SlateBlue;
extern color color.box.shadow = Black;
extern color color.box.red = C'222,192,192';
extern color color.box.green = C'192,222,192';
extern color color.red.rat = Red;
extern color color.green.rat = Green;
extern color color.shadow = Black;

string font.rat = "chinese zodiac";
int font.hud.rat.size = 48;
int font.hud.entry.size = 42;
string font.hud = "David";
int font.rat.size = 20;

color c.box;

datetime hightime,lowtime,barstart,daystart,signaltime;
string pair,TAG;
double point;
double low,high,o,c;
double green.entry.price,red.entry.price;
datetime green.entry.time,red.entry.time;
bool green.entry,red.entry,drawhud;
int hud.r.x,hud.r.y,hud.rs.x,hud.rs.y;
int hud.box.x,hud.box.y,hud.bxb.x,hud.bxb.y,hud.bs.x,hud.bs.y;
int hud.p.x,hud.p.y,hud.ps.x,hud.ps.y;


int init(){
   point = Point;
   if(Digits == 3 || Digits == 5) point*=10;
   c.box = color.box;
   barstart = 0;
   daystart = 0;
   ObDeleteObjectsByPrefix(TAG);
   TAG = CharToStr(0x61+object.layer)+"II_IR";
   pair = Symbol();
   setHUD();
   Comment("");
   DoLogo();
   return(0);
}

int deinit(){
   ObDeleteObjectsByPrefix(TAG);
   return(0);
}

int start(){
   if(daystart != iTime(pair,PERIOD_D1,0)) {
      setVal();
      daystart = iTime(pair,PERIOD_D1,0);
   }
   if(barstart == Time[0] ) return(0);
   ObDeleteObjectsByPrefix(TAG);
   barstart = Time[0];

   setVal();
   entry();
   draw();
   return(0);
}

void entry(){
   drawhud = true;
   if(green.rat){
      green.entry = false;
      int bs = iBarShift(pair,0,signaltime);
      c.box = color.box;
      for(int i=bs;i>0;i--){
         o = Open[i];
         c = Close[i];    
         if(c>o && !green.entry) {
            green.entry.price = High[i];
            green.entry.time = Time[i];
            green.entry = true;
            if(alert.on && i==1) PlaySound(alert.sound);
            if(box.highlight)c.box = color.box.green;
            continue;
         }
         if(green.entry && Open[i] > green.entry.price){
            c.box = color.box;
            if(popup.hud)drawhud = false;
            break;
         }
      }
   }else{
      red.entry = false;
      bs = iBarShift(pair,0,signaltime);
      c.box=color.box;
      for(i=bs;i>0;i--){
         o = Open[i];
         c = Close[i];    
         if(c<o && !red.entry) {
            red.entry.price = Low[i];
            red.entry.time = Time[i];
            red.entry = true;
            if(alert.on && i==1) PlaySound(alert.sound);
            if(box.highlight) c.box = color.box.red;
            continue;
         }
         if(red.entry && Open[i] < red.entry.price){
            c.box = color.box;
            if(popup.hud)drawhud = false;
            break;
         }
      }
   }
}

void setVal(){
   int i,j;
   int limit = iBarShift(pair,0,iTime(pair,PERIOD_D1,0));
   if(green.rat){  
      low = iLow(pair,PERIOD_D1,0);
      lowtime = Time[iLowest(pair,0,MODE_LOW,limit,0)];
      if(extreme.rat && !zone.rat && !all.rat){
         signaltime = lowtime;
         return;
      }
      if(zone.rat && !all.rat){
         for(i=1;i<=limit;i++){
            if(Low[i] < low + 20*point){
               for(j=i+1;j<1000;j++) if(Close[j]>Open[j]) i++;
                                       else break;
               signaltime = Time[i];
               if(signaltime == Time[0]) continue;
               return;
            }
         }
      }
      if(all.rat){
         for(i=0;i<=limit;i++){
            if(Open[i+2]>Close[i+2] && Open[i+1]<Close[i+1]){
               signaltime = Time[i+2];
               return;
            }
         }      
      }
   }else{
      high = iHigh(pair,PERIOD_D1,0);
      hightime = Time[iHighest(pair,0,MODE_HIGH,limit,0)];
      if(extreme.rat && !zone.rat && !all.rat){
         signaltime = hightime;
         return;
      }
      if(zone.rat && !all.rat){
         for(i=1;i<=limit;i++){
            if(High[i] > high - 20*point){
               for(j=i+1;i<1000;j++) if(Close[j]<Open[j]) i++;
                                       else break;
               if(signaltime == Time[0]) continue;                                       
               signaltime = Time[i];
               return;
            }
         }
      }
      if(all.rat){
         for(i=0;i<=limit;i++){
            if(Open[i+2]<Close[i+2] && Open[i+1]>Close[i+1]){
               signaltime = Time[i+2];
               return;
            }
         }      
      }
   }
   Comment("PICK A RAT STYLE:\nEXTREME RAT ENTRY\nZONE RAT ENTRY or\nALL RAT ENTRIES");
}

void draw(){
   ObDeleteObjectsByPrefix(TAG);
   if(show.extreme){
      if(green.rat) DrawRatSymbol("a",low,lowtime,color.green.rat,font.rat,font.rat.size);
         else DrawRatSymbol("A",high,hightime,color.red.rat,font.rat,font.rat.size,180);
   }


   if(popup.hud && !drawhud) return;


   if(green.entry) DrawEntry(SYMBOL_RIGHTPRICE,green.entry.price,green.entry.time,color.green.rat,entry.style,price.size);
      else if(red.entry) DrawEntry(SYMBOL_RIGHTPRICE,red.entry.price,red.entry.time,color.red.rat,entry.style,price.size);

   if(draw.box){
      if(ObjectFind(TAG+".gauge.A1") != 0) DrawCell(0, TAG+".gauge.A1", hud.bs.x, hud.bs.y, 250, 64, color.box.shadow,hud.corner);
      if(ObjectFind(TAG+".gauge.border1") != 0) DrawCell(0, TAG+".gauge.border1", hud.bxb.x, hud.bxb.y, 250, 64, color.box.border,hud.corner);
      if(ObjectFind(TAG+".gauge.box1") != 0) DrawCell(0, TAG+".gauge.box1",    hud.box.x, hud.box.y, 248, 62, c.box,hud.corner);
   }

   if(green.rat) {
      color c = color.green.rat;
      double e = green.entry.price;
   }else{
      c = color.red.rat;
      e = red.entry.price;
      }
   if(e<point) string v = "WAIT ";
      else v = DoubleToStr(e,Digits);
   if(green.rat && !green.entry) v = "WAIT ";
      else if(!green.rat && !red.entry) v = "WAIT ";

   DrawText("a",hud.r.x,hud.r.y,c,font.rat,font.hud.rat.size,hud.corner,0,0,"9");
   DrawText("a",hud.rs.x,hud.rs.y,color.shadow,font.rat,font.hud.rat.size,hud.corner,0,0,"1");
   DrawText(v,hud.p.x,hud.p.y,c,font.hud,font.hud.entry.size,hud.corner,0,0,"9");
   DrawText(v,hud.ps.x,hud.ps.y,color.shadow,font.hud,font.hud.entry.size,hud.corner,0,0,"1");  
}

void DrawText(string t, int x, int y, color c, string f, int s, int k=0, int a=0, bool b=false, string z="")
{
   string tag = TAG+"ZZ"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_LABEL,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_XDISTANCE,x);
   ObjectSet(tag,OBJPROP_YDISTANCE,y);
   ObjectSet(tag,OBJPROP_CORNER,k);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void DrawRatSymbol(string t, double x, datetime y, color c, string f, int s, int a=0, bool b=false, string z="")
{
   string tag = TAG+"ZR"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_TEXT,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,y);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void DrawEntry(string t, double x, datetime y, color c, int s, int w, bool b=false, string z="")
{
   string tag = TAG+"ZA"+z+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_ARROW,0,0,0);
   ObjectSet(tag,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,Time[0]);
   ObjectSet(tag,OBJPROP_COLOR,c);
   ObjectSet(tag,OBJPROP_WIDTH,w);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
   tag = TAG+"ZL"+z+x+y;
   ObjectDelete(tag);   
   ObjectCreate(tag,OBJ_TREND,0,0,0);
   ObjectSet(tag,OBJPROP_PRICE1,x);
   ObjectSet(tag,OBJPROP_TIME1,y);
   ObjectSet(tag,OBJPROP_PRICE2,x);
   ObjectSet(tag,OBJPROP_TIME2,Time[0]);
   ObjectSet(tag,OBJPROP_COLOR,c);
   ObjectSet(tag,OBJPROP_WIDTH,0);
   ObjectSet(tag,OBJPROP_STYLE,s);
   ObjectSet(tag,OBJPROP_RAY,false);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
   
}

void ObDeleteObjectsByPrefix(string Prefix) // code by TRO
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()) {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) {
         i++;
         continue;
      }
      ObjectDelete(ObjName);
   }
}

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr){ //Code from MT4 codebase
   double iHeight, iWidth, iXSpace;
   int iSquares, i;
   if(nWidth > nHeight){
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used.
     iHeight = MathRound((nHeight*100)/77);   // Real height size.
     iWidth = MathRound((nWidth*100)/77);    // Real width size.
     iXSpace = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate(nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText(nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet(nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet(nCellName+i, OBJPROP_YDISTANCE,nY);    
         ObjectSet(nCellName+i, OBJPROP_BACK, false);
         ObjectSet(nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used.
      iHeight  = MathRound((nHeight*100)/77);   // Real height size.
      iWidth   = MathRound((nWidth*100)/77);    // Real width size.
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
      }
   }
}

void setHUD(){
   if(hud.corner > 3) hud.corner=0;
   switch(hud.corner){
      case 0 : hud.box.x = pos.x-97;
               hud.box.y = pos.y+6;
               hud.bs.x = pos.x-97;
               hud.bs.y = pos.y+6;
               hud.bxb.x = pos.x-98;
               hud.bxb.y = pos.y+5;
               hud.r.x = pos.x-85;
               hud.r.y = pos.y+31;
               hud.rs.x = pos.x-84;
               hud.rs.y = pos.y+32;
               hud.p.x = pos.x-15;
               hud.p.y = pos.y+38;
               hud.ps.x = pos.x-14;
               hud.ps.y = pos.y+39;
               break;
      case 1 : hud.box.x = pos.x-97;
               hud.box.y = pos.y+6;
               hud.bs.x = pos.x-99;
               hud.bs.y = pos.y+6;
               hud.bxb.x = pos.x-98;
               hud.bxb.y = pos.y+5;
               hud.r.x = pos.x+90;
               hud.r.y = pos.y+31;
               hud.rs.x = pos.x+89;
               hud.rs.y = pos.y+32;
               hud.p.x = pos.x-86;
               hud.p.y = pos.y+38;
               hud.ps.x = pos.x-87;
               hud.ps.y = pos.y+39;
               break;
      case 2 : hud.box.x = pos.x-97;
               hud.box.y = pos.y+6;
               hud.bs.x = pos.x-97;
               hud.bs.y = pos.y+4;
               hud.bxb.x = pos.x-98;
               hud.bxb.y = pos.y+5;
               hud.r.x = pos.x-85;
               hud.r.y = pos.y+39;
               hud.rs.x = pos.x-84;
               hud.rs.y = pos.y+38;
               hud.p.x = pos.x-15;
               hud.p.y = pos.y+38;
               hud.ps.x = pos.x-14;
               hud.ps.y = pos.y+39;
               break;
      case 3 : hud.box.x = pos.x-96;
               hud.box.y = pos.y+6;
               hud.bs.x = pos.x-98;
               hud.bs.y = pos.y+4;
               hud.bxb.x = pos.x-97;
               hud.bxb.y = pos.y+5;
               hud.r.x = pos.x+90;
               hud.r.y = pos.y+39;
               hud.rs.x = pos.x+89;
               hud.rs.y = pos.y+38;
               hud.p.x = pos.x-86;
               hud.p.y = pos.y+38;
               hud.ps.x = pos.x-87;
               hud.ps.y = pos.y+39;
               break;
   }

}

void DoLogo(){
   string TAG = CharToStr(0x61+27)+"II_Logo";
   if( ObjectFind(TAG+"ZZ"+0) >= 0 && ObjectFind(TAG+"ZZ"+1) >= 0 && ObjectFind(TAG+"ZZ"+2) >= 0  && 
       ObjectFind(TAG+"AZ"+0) >= 0 && ObjectFind(TAG+"AZ"+1) >= 0 && ObjectFind(TAG+"AZ"+2) >= 0 ) return;
   string str[3] = {"$","Insanity","Industries"};
   int size[3] = {25,10,10};
   int pos.x[3] = {47,19,17};
   int pos.y[3] = {10,25,15};
   int pos.xs[3] = {46,18,16};
   int pos.ys[3] = {9,24,14};
   for(int i=0;i<3;i++){
      string n = TAG+"ZZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",AliceBlue);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.x[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.y[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
      n = TAG+"AZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",Black);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.xs[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.ys[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
   }
}